/***************************************************************************
 *   Copyright (C) 2005 by Joachim Friedrich                               *
 *   joachim.friedrich@biozentrum.uni-wuerzburg.de                         *
 *                                                                         *
 *   This file is part of profdist and cbcanalyzer                         *
 *                                                                         *
 *   Both profdist and cbcanalyzer are free software; you can redistribute *
 *   it and/or modify it under the terms of the GNU General Public License *
 *   as published by the Free Software Foundation; either version 2 of the *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   Profdist and cbcanalyzer are distributed in the hope that it will be  *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// -*- C++ -*- generated by wxGlade 0.3.2 on Thu Jul 01 16:50:26 2004
#include <cstdlib>
#include <exception>
#include <fstream>
#include <cstdio>
#include <boost/version.hpp>
#include <ctime>
#include "ProfDist.h"
#include "wxEvent.h"
#include "converter.h"
#include <wx/msgdlg.h>
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef WINDOWS_SYSTEM
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <fcntl.h>
#endif 

#ifdef DARWIN_SYSTEM
#include <Carbon/Carbon.h>
#endif


MyFrame::MyFrame( wxWindow * parent, int id, const wxString & title, const wxPoint & pos, const wxSize & size, long style ) 
  :  wxFrame( parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE ), help( wxHF_DEFAULT_STYLE | wxHF_OPEN_FILES )
{

  std::memset( flags, 0, sizeof(flags) );

  help.UseConfig( wxConfig::Get() );
  bool ret;
#ifndef DARWIN_SYSTEM
  help.SetTempDir( wxT( "." ) ); // wxT ??
  ret = help.AddBook( wxFileName( wxString( convert(MyApp::get_help_path() + "/help.hhp").c_str() ), wxPATH_UNIX ) );
  if ( !ret )
    wxMessageBox( wxString( convert("Failed adding book " +  MyApp::get_help_path() +  "/help.hhp").c_str() ) );
#endif

  // Set up toolbar
  wxBitmap toolBarBitmaps[10];
  toolBarBitmaps[0] = wxBitmap( open_xpm );
  toolBarBitmaps[1] = wxBitmap( save_xpm );
  toolBarBitmaps[2] = wxBitmap( undo_xpm );
  toolBarBitmaps[3] = wxBitmap( copy_xpm );
  toolBarBitmaps[4] = wxBitmap( cut_xpm );
  toolBarBitmaps[5] = wxBitmap( paste_xpm );
  toolBarBitmaps[6] = wxBitmap( run_xpm );
  toolBarBitmaps[7] = wxBitmap( tree_xpm );
  toolBarBitmaps[8] = wxBitmap( pref_xpm );
  toolBarBitmaps[9] = wxBitmap( help_xpm );

  // begin wxGlade: MyFrame::MyFrame
  ntbAll = new wxNotebook(this, idNtbAll, wxDefaultPosition, wxDefaultSize, 0);
  ntbPnj = new wxPanel(ntbAll, idNtbPnj, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
  ntbConsense = new wxPanel(ntbAll, idNtbConsense, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
  ntbSystematic = new wxPanel(ntbAll, idNtbNj, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
  ntbDistance = new wxPanel(ntbAll, idNtbDistance, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
  ntbBootstrap = new wxPanel(ntbAll, idNtbBootstrap, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
  sizer_11_staticbox = new wxStaticBox(ntbBootstrap, -1, _("output"));
  sizer_10_copy_staticbox = new wxStaticBox(ntbDistance, -1, _("input"));
  sizer_11_copy_staticbox = new wxStaticBox(ntbDistance, -1, _("output"));
  szNjInput_staticbox = new wxStaticBox(ntbSystematic, -1, _("input"));
  szNjOutput_staticbox = new wxStaticBox(ntbSystematic, -1, _("output"));
  szConsOutput_staticbox = new wxStaticBox(ntbConsense, -1, _("output"));
  szConsInput_staticbox = new wxStaticBox(ntbConsense, -1, _("input"));
  szPnjInput_staticbox = new wxStaticBox(ntbPnj, -1, _("input"));
  szPnjOutput_staticbox = new wxStaticBox(ntbPnj, -1, _("output"));
  sizer_10_staticbox = new wxStaticBox(ntbBootstrap, -1, _("input"));
  frame_1_menubar = new wxMenuBar();
  SetMenuBar(frame_1_menubar);
  wxMenu* wxglade_tmp_menu_1 = new wxMenu();
  wxglade_tmp_menu_1->Append(idMnuOpen, _("Open File...\tCtrl-O"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_1->Append(idMnuSave, _("Save\tCtrl-S"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_1->AppendSeparator();
  wxglade_tmp_menu_1->Append(idMnuExit, _("Exit\tAlt-X"), wxT(""), wxITEM_NORMAL);
  frame_1_menubar->Append(wxglade_tmp_menu_1, _("File"));
  wxMenu* wxglade_tmp_menu_2 = new wxMenu();
  wxglade_tmp_menu_2->Append(idMnuUndo, _("&Undo\tCtrl-Z"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_2->AppendSeparator();
  wxglade_tmp_menu_2->Append(idMnuCut, _("Cu&t\tCtrl-X"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_2->Append(idMnuCopy, _("&Copy\tCtrl-C"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_2->Append(idMnuPaste, _("&Paste\tCtrl-V"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_2->AppendSeparator();
  wxglade_tmp_menu_2->Append(idMnuSelectAll, _("Select All\tCtrl-A"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_2->AppendSeparator();
  wxglade_tmp_menu_2->Append(idMnuPref, _("Pr&eferences..."), wxT(""), wxITEM_NORMAL);
  frame_1_menubar->Append(wxglade_tmp_menu_2, _("Edit"));
  wxMenu* wxglade_tmp_menu_3 = new wxMenu();
  wxglade_tmp_menu_3->Append(idMnuStart, _("&Run...\tCtrl-R"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_3->Append(idMnuTreeView, _("&View Tree\tCtrl-T"), wxT(""), wxITEM_NORMAL);
  frame_1_menubar->Append(wxglade_tmp_menu_3, _("Functions"));
  wxMenu* wxglade_tmp_menu_4 = new wxMenu();
#ifndef DARWIN_SYSTEM
  wxglade_tmp_menu_4->Append(idMnuHelp, _("&Help"), wxT(""), wxITEM_NORMAL);
  wxglade_tmp_menu_4->AppendSeparator();
#endif
  wxglade_tmp_menu_4->Append(idMnuAbout, _("&About..."), wxT(""), wxITEM_NORMAL);
#ifndef DARWIN_SYSTEM
  frame_1_menubar->Append(wxglade_tmp_menu_4, _("Help"));
#else 
  frame_1_menubar->Append(wxglade_tmp_menu_4, _("Info"));
#endif
  frame_1_statusbar = CreateStatusBar(1, 0);
  frame_toolbar = new wxToolBar(this, -1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL|wxTB_FLAT);
  SetToolBar(frame_toolbar);
  frame_toolbar->SetToolBitmapSize(wxSize(16, 16));
  frame_toolbar->AddTool(idMnuOpen, _("Open File"), (toolBarBitmaps[0]), wxNullBitmap, wxITEM_NORMAL, _("Open File"), wxT(""));
  frame_toolbar->AddTool(idMnuSave, _("Save"), (toolBarBitmaps[1]), wxNullBitmap, wxITEM_NORMAL, _("Save"), wxT(""));
  frame_toolbar->AddSeparator();
  frame_toolbar->AddTool(idMnuUndo, _("Undo"), (toolBarBitmaps[2]), wxNullBitmap, wxITEM_NORMAL, _("Undo"), wxT(""));
  frame_toolbar->AddSeparator();
  frame_toolbar->AddTool(idMnuCopy, _("Copy"), (toolBarBitmaps[3]), wxNullBitmap, wxITEM_NORMAL, _("Copy"), wxT(""));
  frame_toolbar->AddTool(idMnuCut, _("Cut"), (toolBarBitmaps[4]), wxNullBitmap, wxITEM_NORMAL, _("Cut"), wxT(""));
  frame_toolbar->AddTool(idMnuPaste, _("Paste"), (toolBarBitmaps[5]), wxNullBitmap, wxITEM_NORMAL, _("Paste"), wxT(""));
  frame_toolbar->AddSeparator();
  frame_toolbar->AddTool(idMnuStart, _("Run"), (toolBarBitmaps[6]), wxNullBitmap, wxITEM_NORMAL, _("Run"), wxT(""));
  frame_toolbar->AddTool(idMnuTreeView, _("Tree"), (toolBarBitmaps[7]), wxNullBitmap, wxITEM_NORMAL, _("Tree Preview"), wxT(""));
  frame_toolbar->AddSeparator();
  frame_toolbar->AddTool(idMnuPref, _("Preferences"), (toolBarBitmaps[8]), wxNullBitmap, wxITEM_NORMAL, _("Preferences"), wxT(""));
#ifndef DARWIN_SYSTEM
  frame_toolbar->AddSeparator();
  frame_toolbar->AddTool(idMnuHelp, _("Help"), (toolBarBitmaps[9]), wxNullBitmap, wxITEM_NORMAL, _("Help"), wxT(""));
#endif
  frame_toolbar->Realize();
  txtBootInput = new wxTextCtrl(ntbBootstrap, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoBootInput_choices[] = {
    _("Fasta"),
    _("Embl")
  };
  rdoBootInput = new wxRadioBox(ntbBootstrap, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 2, rdoBootInput_choices, 1, wxRA_SPECIFY_COLS);
  chkBootInput = new wxCheckBox(ntbBootstrap, idChkBootInput, _("input window"));
  txtBootOutput = new wxTextCtrl(ntbBootstrap, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoBootOutput_choices[] = {
    _("Fasta")
  };
  rdoBootOutput = new wxRadioBox(ntbBootstrap, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoBootOutput_choices, 1, wxRA_SPECIFY_COLS);
  chkBootOutput = new wxCheckBox(ntbBootstrap, idChkBootOutput, _("output window"));
  txtDistInput = new wxTextCtrl(ntbDistance, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoDistInput_choices[] = {
    _("Fasta")
    ,_("Embl")
//     ,_("Bdb")
//     ,_("Marna")
//     ,_("Forester")
  };
  rdoDistInput = new wxRadioBox(ntbDistance, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 2/*5*/, rdoDistInput_choices, 1, wxRA_SPECIFY_COLS);
  chkDistMultiple = new wxCheckBox(ntbDistance, idChkDistInput, _("multiple data"));
  chkDistInput = new wxCheckBox(ntbDistance, idChkDistInput, _("input window"));
  txtDistOutput = new wxTextCtrl(ntbDistance, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoDistOutput_choices[] = {
    _("Matrix")
  };
  rdoDistOutput = new wxRadioBox(ntbDistance, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoDistOutput_choices, 1, wxRA_SPECIFY_COLS);
  chkDistOutput = new wxCheckBox(ntbDistance, idChkDistOutput, _("output window"));
  txtNjInput = new wxTextCtrl(ntbSystematic, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoNjInput_choices[] = {
    _("Matrix")
  };
  rdoNjInput = new wxRadioBox(ntbSystematic, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoNjInput_choices, 1, wxRA_SPECIFY_COLS);
  chkNjMultiple = new wxCheckBox(ntbSystematic, idChkNjMultiple, _("multiple data"));
  chkNjInput = new wxCheckBox(ntbSystematic, idChkNjInput, _("input window"));
  txtNjOutput = new wxTextCtrl(ntbSystematic, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoNjOutput_choices[] = {
    _("Newick")
  };
  rdoNjOutput = new wxRadioBox(ntbSystematic, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoNjOutput_choices, 1, wxRA_SPECIFY_COLS);
  chkNjOutput = new wxCheckBox(ntbSystematic, idChkNjOutput, _("output window"));
  txtConsInput = new wxTextCtrl(ntbConsense, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoConsInput_choices[] = {
    _("Newick")
  };
  rdoConsInput = new wxRadioBox(ntbConsense, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoConsInput_choices, 1, wxRA_SPECIFY_COLS);
  
  txtConsOutput = new wxTextCtrl(ntbConsense, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoConsOutput_choices[] = {
    _("Newick")
  };
  rdoConsOutput = new wxRadioBox(ntbConsense, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoConsOutput_choices, 1, wxRA_SPECIFY_COLS);
  txtPnjInput = new wxTextCtrl(ntbPnj, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoPnjInput_choices[] = {
    _("Fasta")
    , _("Embl")
//     , _("Bdb")
//     , _("Marna")
//     , _("Forester")
  };
  rdoPnjInput = new wxRadioBox(ntbPnj, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 2/*5*/, rdoPnjInput_choices, 1, wxRA_SPECIFY_COLS);
  chkPnjInput = new wxCheckBox(ntbPnj, idChkPnjInput, _("input window"));
  txtPnjOutput = new wxTextCtrl(ntbPnj, -1, wxT(""), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxHSCROLL|wxTE_RICH2);
  const wxString rdoPnjOutput_choices[] = {
    _("Newick")
  };
  rdoPnjOutput = new wxRadioBox(ntbPnj, -1, _("File Format"), wxDefaultPosition, wxDefaultSize, 1, rdoPnjOutput_choices, 1, wxRA_SPECIFY_COLS);
  chkPnjOutput = new wxCheckBox(ntbPnj, idChkPnjOutput, _("ouput window"));

  set_properties();
  do_layout();
  // end wxGlade
}


void MyFrame::set_properties()
{
  // Set up toolbar
  wxBitmap toolBarBitmaps[1];
  toolBarBitmaps[0] = wxBitmap( present_xpm );

  wxIcon _icon;
  _icon.CopyFromBitmap( toolBarBitmaps[0] );
  SetIcon( _icon );

  // begin wxGlade: MyFrame::set_properties
  SetTitle(_("ProfDist"));
  SetSize(wxSize(634, 600));
  int frame_1_statusbar_widths[] = { -1 };
  frame_1_statusbar->SetStatusWidths(1, frame_1_statusbar_widths);
  const wxString frame_1_statusbar_fields[] = {
    _("A tool for the construction of large phylogenetic trees based on profile distances")
  };
  for(int i = 0; i < frame_1_statusbar->GetFieldsCount(); ++i) {
    frame_1_statusbar->SetStatusText(frame_1_statusbar_fields[i], i);
  }
  txtBootInput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoBootInput->SetSelection(0);
  chkBootInput->SetSize(wxSize(90, -1));
  chkBootInput->Hide();
  chkBootInput->SetValue(1);
  txtBootOutput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoBootOutput->SetSelection(0);
  chkBootOutput->SetSize(wxSize(90, -1));
  chkBootOutput->Hide();
  chkBootOutput->SetValue(1);
  txtDistInput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoDistInput->SetSelection(0);
  chkDistInput->SetSize(wxSize(90, -1));
  chkDistInput->Hide();
  chkDistInput->SetValue(1);
  txtDistOutput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoDistOutput->SetSelection(0);
  chkDistOutput->SetSize(wxSize(90, -1));
  chkDistOutput->Hide();
  chkDistOutput->SetValue(1);
  txtNjInput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoNjInput->SetSelection(0);
  chkNjInput->SetSize(wxSize(90, -1));
  chkNjInput->Hide();
  chkNjInput->SetValue(1);
  txtNjOutput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoNjOutput->SetSelection(0);
  chkNjOutput->SetSize(wxSize(90, -1));
  chkNjOutput->Hide();
  chkNjOutput->SetValue(1);
  txtConsInput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoConsInput->SetSelection(0);
  rdoConsInput->SetSize(wxSize(90, -1));
  txtConsOutput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoConsOutput->SetSelection(0);
  rdoConsOutput->SetSize(wxSize(90, -1));
  txtPnjInput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoPnjInput->SetSelection(0);
  chkPnjInput->SetSize(wxSize(90, -1));
  chkPnjInput->SetValue(1);
  txtPnjOutput->SetFont(wxFont(9, wxMODERN, wxNORMAL, wxNORMAL, 0, _T("Courier New")));
  rdoPnjOutput->SetSelection(0);
  chkPnjOutput->SetSize(wxSize(90, -1));
  chkPnjOutput->Hide();
  chkPnjOutput->SetValue(1);
  // end wxGlade
}


void MyFrame::do_layout()
{
  // begin wxGlade: MyFrame::do_layout
  wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* szMainPnj = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* szPnjInOuput = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* szPnjOutput = new wxStaticBoxSizer(szPnjOutput_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_8 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* szPnjInput = new wxStaticBoxSizer(szPnjInput_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_19 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* cons_input_sizer = new wxStaticBoxSizer(szConsInput_staticbox, wxHORIZONTAL);
  wxStaticBoxSizer* cons_output_sizer = new wxStaticBoxSizer(szConsOutput_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_4 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_5_copy_1 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_9_copy_1 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* szNjOutput = new wxStaticBoxSizer(szNjOutput_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_13 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* szNjInput = new wxStaticBoxSizer(szNjInput_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_12 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_13_cons = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_5_copy = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_9_copy = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* sizer_11_copy = new wxStaticBoxSizer(sizer_11_copy_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_21 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* sizer_10_copy = new wxStaticBoxSizer(sizer_10_copy_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_20 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_5 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* consense_base_sizer = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_9 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* sizer_11 = new wxStaticBoxSizer(sizer_11_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_22 = new wxBoxSizer(wxVERTICAL);
  wxStaticBoxSizer* sizer_10 = new wxStaticBoxSizer(sizer_10_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_17 = new wxBoxSizer(wxVERTICAL);

  sizer_5->Add(5, 5, 0, 0, 0);
  sizer_10->Add(txtBootInput, 1, wxEXPAND, 0);
  sizer_10->Add(5, 5, 0, 0, 0);
  sizer_17->Add(rdoBootInput, 0, wxEXPAND, 0);
  sizer_17->Add(5, 5, 0, 0, 0);
  sizer_17->Add(chkBootInput, 0, 0, 0);
  sizer_10->Add(sizer_17, 0, wxEXPAND, 0);
  sizer_9->Add(sizer_10, 1, wxEXPAND, 0);
  sizer_11->Add(txtBootOutput, 1, wxEXPAND, 0);
  sizer_11->Add(5, 5, 0, 0, 0);
  sizer_22->Add(rdoBootOutput, 0, wxEXPAND, 0);
  sizer_22->Add(5, 5, 0, 0, 0);
  sizer_22->Add(chkBootOutput, 0, 0, 0);
  sizer_11->Add(sizer_22, 0, wxEXPAND, 0);
  sizer_9->Add(sizer_11, 1, wxEXPAND, 0);
  sizer_5->Add(sizer_9, 1, wxEXPAND, 0);
  sizer_5->Add(5, 5, 0, 0, 0);
  ntbBootstrap->SetAutoLayout(true);
  ntbBootstrap->SetSizer(sizer_5);
  sizer_5->Fit(ntbBootstrap);
  sizer_5->SetSizeHints(ntbBootstrap);
  
  sizer_5_copy->Add(5, 5, 0, 0, 0);
  sizer_10_copy->Add(txtDistInput, 1, wxEXPAND, 0);
  sizer_10_copy->Add(5, 5, 0, 0, 0);
  sizer_20->Add(rdoDistInput, 0, wxEXPAND, 0);
  sizer_20->Add(5, 5, 0, 0, 0);
  sizer_20->Add(chkDistMultiple, 0, 0, 0);
  sizer_20->Add(5, 5, 0, 0, 0);
  sizer_20->Add(chkDistInput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  sizer_10_copy->Add(sizer_20, 0, wxEXPAND, 0);
  sizer_9_copy->Add(sizer_10_copy, 1, wxEXPAND, 0);
  sizer_11_copy->Add(txtDistOutput, 1, wxEXPAND, 0);
  sizer_11_copy->Add(5, 5, 0, 0, 0);
  sizer_21->Add(rdoDistOutput, 0, wxEXPAND, 0);
  sizer_21->Add(5, 5, 0, 0, 0);
  sizer_21->Add(chkDistOutput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  sizer_11_copy->Add(sizer_21, 0, wxEXPAND, 0);
  sizer_9_copy->Add(sizer_11_copy, 1, wxEXPAND, 0);
  sizer_5_copy->Add(sizer_9_copy, 1, wxEXPAND, 0);
  sizer_5_copy->Add(5, 5, 0, 0, 0);
  ntbDistance->SetAutoLayout(true);
  ntbDistance->SetSizer(sizer_5_copy);
  sizer_5_copy->Fit(ntbDistance);
  sizer_5_copy->SetSizeHints(ntbDistance);
  
  sizer_5_copy_1->Add(5, 5, 0, 0, 0);
  szNjInput->Add(txtNjInput, 1, wxEXPAND, 0);
  szNjInput->Add(5, 5, 0, 0, 0);
  sizer_12->Add(rdoNjInput, 0, wxEXPAND, 0);
  sizer_12->Add(5, 5, 0, 0, 0);
  sizer_12->Add(chkNjMultiple, 0, 0, 0);
  sizer_12->Add(5, 5, 0, 0, 0);
  sizer_12->Add(chkNjInput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  szNjInput->Add(sizer_12, 0, 0, 0);
  sizer_9_copy_1->Add(szNjInput, 1, wxEXPAND, 0);
  szNjOutput->Add(txtNjOutput, 1, wxEXPAND, 0);
  szNjOutput->Add(5, 5, 0, 0, 0);
  sizer_13->Add(rdoNjOutput, 0, wxEXPAND, 0);
  sizer_13->Add(5, 5, 0, 0, 0);
  sizer_13->Add(chkNjOutput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  szNjOutput->Add(sizer_13, 0, wxEXPAND, 0);
  sizer_9_copy_1->Add(szNjOutput, 1, wxEXPAND, 0);
  sizer_5_copy_1->Add(sizer_9_copy_1, 1, wxEXPAND, 0);
  sizer_5_copy_1->Add(5, 5, 0, 0, 0);
  ntbSystematic->SetAutoLayout(true);
  ntbSystematic->SetSizer(sizer_5_copy_1);
  sizer_5_copy_1->Fit(ntbSystematic);
  sizer_5_copy_1->SetSizeHints(ntbSystematic);



  wxBoxSizer* left_cons_input_sizer = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* left_cons_output_sizer = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* cons_conn_sizer = new wxBoxSizer(wxVERTICAL);
  consense_base_sizer->Add(5, 5, 0, 0, 0);
  cons_input_sizer->Add(txtConsInput, 1, wxEXPAND, 0);
  cons_input_sizer->Add(5, 5, 0, 0, 0);
  left_cons_input_sizer->Add(rdoConsInput, 0, wxEXPAND, 0);
  left_cons_input_sizer->Add(5, 5, 0, 0, 0);
  cons_input_sizer->Add(left_cons_input_sizer, 0, wxEXPAND, 0);
  cons_conn_sizer->Add(cons_input_sizer, 1, wxEXPAND, 0);
  cons_output_sizer->Add(txtConsOutput, 1, wxEXPAND, 0);
  cons_output_sizer->Add(5, 5, 0, 0, 0);
  left_cons_output_sizer->Add(rdoConsOutput, 0, wxEXPAND, 0);
  cons_output_sizer->Add(left_cons_output_sizer, 0, wxEXPAND, 0);
  cons_conn_sizer->Add(cons_output_sizer, 1, wxEXPAND, 0);
  consense_base_sizer->Add(cons_conn_sizer, 1, wxEXPAND, 0);
  consense_base_sizer->Add(5, 5, 0, 0, 0);
  ntbConsense->SetAutoLayout(true);
  ntbConsense->SetSizer(consense_base_sizer);
  consense_base_sizer->Fit(ntbConsense);
  consense_base_sizer->SetSizeHints(ntbConsense);
  
   
  szMainPnj->Add(5, 5, 0, 0, 0);
  szPnjInput->Add(txtPnjInput, 1, wxEXPAND, 0);
  szPnjInput->Add(5, 5, 0, 0, 0);
  sizer_19->Add(rdoPnjInput, 0, wxEXPAND, 0);
  sizer_19->Add(5, 5, 0, 0, 0);
  sizer_19->Add(chkPnjInput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  szPnjInput->Add(sizer_19, 0, wxEXPAND, 0);
  szPnjInOuput->Add(szPnjInput, 1, wxEXPAND, 0);
  szPnjOutput->Add(txtPnjOutput, 1, wxEXPAND, 0);
  szPnjOutput->Add(5, 5, 0, 0, 0);
  sizer_8->Add(rdoPnjOutput, 0, wxEXPAND, 0);
  sizer_8->Add(5, 5, 0, 0, 0);
  sizer_8->Add(chkPnjOutput, 0, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
  szPnjOutput->Add(sizer_8, 0, wxEXPAND, 0);
  szPnjInOuput->Add(szPnjOutput, 1, wxEXPAND, 0);
  szMainPnj->Add(szPnjInOuput, 1, wxEXPAND, 0);
  szMainPnj->Add(5, 5, 0, 0, 0);
  ntbPnj->SetAutoLayout(true);
  ntbPnj->SetSizer(szMainPnj);
  szMainPnj->Fit(ntbPnj);
  szMainPnj->SetSizeHints(ntbPnj);
  ntbAll->AddPage(ntbBootstrap, _("Bootstrap"));
  ntbAll->AddPage(ntbDistance, _("Distance"));
  ntbAll->AddPage(ntbSystematic, _("Neighbor Joining"));
  ntbAll->AddPage(ntbConsense, _("Consense"));
  ntbAll->AddPage(ntbPnj, _("Profile Neighbor Joining"));
  sizer_1->Add(new wxNotebookSizer(ntbAll), 1, wxEXPAND, 0);
  SetAutoLayout(true);
  SetSizer(sizer_1);
  Layout();
  Centre();
  // end wxGlade
}


  MyDialogPref::MyDialogPref( wxWindow * parent, int id, const wxString & title, const wxPoint & pos, const wxSize & size, long style ) 
: wxDialog( parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE )
{
  help.UseConfig( wxConfig::Get() );
  bool ret;
#ifndef DARWIN_SYSTEM
  help.SetTempDir( wxT( "." ) );
  ret = help.AddBook( wxFileName( wxString( convert(MyApp::get_help_path()+ "/help.hhp").c_str()) ), wxPATH_UNIX );
  if ( !ret )
    wxMessageBox( wxString( convert("Failed adding book " + MyApp::get_help_path() + "/help.hhp" ).c_str() ) );
#endif


  // Set up toolbar
  wxBitmap toolBarBitmaps[1];
  toolBarBitmaps[0] = wxBitmap( open_xpm );

  // begin wxGlade: MyDialogPref::MyDialogPref
  ratematrix_staticbox = new wxStaticBox(this, -1, _("Ratematrix Q"));
  szPrefDistance_staticbox = new wxStaticBox(this, -1, _("Distance"));
  threshold_static_box = new wxStaticBox(this, -1, _("Threshold"));
  embl_static_box = new wxStaticBox(this, -1, _("Embl / GenBank "));
  pnj_settings_staticbox = new wxStaticBox(this, -1, _("Profile Neighbor Joining"));
  szPrefTreeViewer_staticbox = new wxStaticBox(this, -1, _("Tree Viewer"));
  szPrefBootstrap_staticbox = new wxStaticBox(this, -1, _("Bootstrap"));
  label_1 = new wxStaticText(this, -1, _("Number of Bootstraps"));
  rate_matrix_label = new wxStaticText(this, -1, _("Choose a rate matrix file:"));
  bootstrap_comment = new wxStaticText(this, -1, _("Values between 100 and 1000, are recommended."));
  txtPrefNumberBoot = new wxTextCtrl(this, -1, wxT(""));
  const wxString rdoPrefEvolution_choices[] = {
    _("Jukes Cantor"),
    _("Kimura 2-Parameter"),
    _("General Time Reversible"),
    _("Log Det")
  };
  rdoPrefEvolution = new wxRadioBox(this, idRdoPrefEvolution, _("Correction Model"), wxDefaultPosition, wxDefaultSize, 4, rdoPrefEvolution_choices, 1, wxRA_SPECIFY_COLS);
  //const wxString rdoPrefMatrixExpm_choices[] = {
  //  _("Pade Approximation"),
  //  _("Taylor Series"),
  //  _("Eigenvalues")
  //};
  //rdoPrefMatrixExpm = new wxRadioBox(this, -1, _("Matrix Exponential"), wxDefaultPosition, wxDefaultSize, 3, rdoPrefMatrixExpm_choices, 1, wxRA_SPECIFY_COLS);
  const wxString rdoPrefMaximum_choices[] = {
    //_("f' Zero Point Search"),
    _("Newton Method"),
    _("Robust")
    //_("Parabolic")
  };
  rdoPrefMaximum = new wxRadioBox(this, -1, _("Function Maximization"), wxDefaultPosition, wxDefaultSize, 2, rdoPrefMaximum_choices, 1, wxRA_SPECIFY_COLS);
  txtPrefRatematrix = new wxTextCtrl(this, -1, wxT(""));
  btnPrefOpenRatematrix = new wxBitmapButton(this, idBtnPrefOpenRatematrix, (toolBarBitmaps[0]));
  const wxString rdoPrefPnjType_choices[] = {
    _("manual"),
    _("half automatic (every step)"),
    _("half automatic (first step)"),
    _("automatic")
  };
  rdoPrefPnjType = new wxRadioBox(this, -1, _("Generating Profiles Method"), wxDefaultPosition, wxDefaultSize, 4, rdoPrefPnjType_choices, 1, wxRA_SPECIFY_COLS);
  label_2 = new wxStaticText(this, -1, _("1. threshold for profile generation: Minimal bootstrap value (%)"));
  txtPrefProfBootValue = new wxTextCtrl(this, -1, wxT(""));
  label_3 = new wxStaticText(this, -1, _("2. threshold for profile generation: Percent identitiy (uncorrected p-distances)"));
  txtPrefProfPercentIdent = new wxTextCtrl(this, -1, wxT(""));
  chkPrefShowOC = new wxCheckBox(this, -1, _("Show organism classification and preselect (define) profiles"));
  rdoPrefTree1 = new wxRadioButton(this, idRdoPrefTree1, _("Tree Viewer 1"));
  txtPrefTreeViewer1 = new wxTextCtrl(this, -1, wxT(""));
  btnPrefOpenTreeViewer1 = new wxBitmapButton(this, idBtnPrefOpenTreeViewer1, (toolBarBitmaps[0]));
  rdoPrefTree2 = new wxRadioButton(this, idRdoPrefTree2, _("Tree Viewer 2"));
  txtPrefTreeViewer2 = new wxTextCtrl(this, -1, wxT(""));
  btnPrefOpenTreeViewer2 = new wxBitmapButton(this, idBtnPrefOpenTreeViewer2, (toolBarBitmaps[0]));
  rdoPrefNoneTree = new wxRadioButton(this, idRdoPrefNone, _("None"));
  text_label_1 = new wxStaticText(this, -1, _("Only the first tree is shown by typical treeviewers like NJplot or hypergeny. You can\n"
                                              "edit the output of profdist to make the other trees visible. In Treeview click on the\n"
                                              "upper left arrows to scroll through all trees estimated.")
      , wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT);
  btnPrefOk = new wxButton(this, idBtnPrefOk, _("OK"));
  btnPrefCancel = new wxButton(this, idBtnPrefCancel, _("Cancel"));
#ifndef DARWIN_SYSTEM
  btnPrefHelp = new wxButton(this, idBtnPrefHelp, _("Help"));
#endif
  btnPrefExpert = new wxButton(this, idBtnPrefExpert, _("Expert"));

  set_properties();
  do_layout();
  // end wxGlade
}


void MyDialogPref::set_properties()
{
  // begin wxGlade: MyDialogPref::set_properties
  SetTitle(_("Preferences"));
  txtPrefNumberBoot->SetSize(wxSize(50, -1));
  rdoPrefEvolution->SetSelection(0);
  //rdoPrefMatrixExpm->SetForegroundColour(wxColour(50, 50, 204));
  //rdoPrefMatrixExpm->Enable( false );
  //rdoPrefMatrixExpm->SetSelection(0);
  rdoPrefMaximum->SetForegroundColour(wxColour(50, 50, 204));
  rdoPrefMaximum->Enable( false );
  rdoPrefMaximum->SetSelection(0);
  txtPrefRatematrix->SetSize(wxSize(525, -1));
  btnPrefOpenRatematrix->SetSize(wxSize(25, 25));
  rdoPrefPnjType->SetSelection(0);
  txtPrefProfBootValue->SetSize(wxSize(50, 21));
  txtPrefProfPercentIdent->SetSize(wxSize(50, -1));
  txtPrefTreeViewer1->SetSize(wxSize(400, -1));
  btnPrefOpenTreeViewer1->SetSize(wxSize(23, 23));
  txtPrefTreeViewer2->SetSize(wxSize(400, -1));
  btnPrefOpenTreeViewer2->SetSize(wxSize(23, 23));
  //text_label_1->SetSize(wxSize(50, 400));
//  text_label_1->SetBackgroundColour(wxSystemSettings::GetSystemColour(wxSYS_COLOUR_WINDOWFRAME));
  //text_label_1->Enable(false);
  btnPrefOk->SetDefault();
  // end wxGlade
}


void MyDialogPref::do_layout()
{
  // begin wxGlade: MyDialogPref::do_layout
  wxBoxSizer* complete_sizer = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* szPrefButtons = new wxBoxSizer(wxHORIZONTAL);
  wxStaticBoxSizer* szPrefTreeViewer = new wxStaticBoxSizer(szPrefTreeViewer_staticbox, wxHORIZONTAL);
  wxBoxSizer* sizer_42 = new wxBoxSizer(wxVERTICAL);
  wxFlexGridSizer* tree_view_settings_grid_sizer = new wxFlexGridSizer(5, 3, 5, 5);
  wxStaticBoxSizer* pnj_settings_sizer = new wxStaticBoxSizer(pnj_settings_staticbox, wxVERTICAL);
  complete_sizer->Add(5, 5, 0, 0, 0);
  wxBoxSizer* vertical_main_sizer = new wxBoxSizer(wxVERTICAL);
  {
    vertical_main_sizer->Add(5, 5, 0, 0, 0);
    wxStaticBoxSizer* bootstrap_settings_static_box_sizer = new wxStaticBoxSizer(szPrefBootstrap_staticbox, wxHORIZONTAL);  
    {
      bootstrap_settings_static_box_sizer->Add(label_1, 0, wxALIGN_CENTER_VERTICAL, 0);
      bootstrap_settings_static_box_sizer->Add(5, 5, 0, 0, 0);
      bootstrap_settings_static_box_sizer->Add(txtPrefNumberBoot, 0, 0, 0);
      bootstrap_settings_static_box_sizer->Add(5, 5, 0, 0, 0);
      bootstrap_settings_static_box_sizer->Add(bootstrap_comment, 0, wxALIGN_CENTER_VERTICAL, 0);
    }
    
    vertical_main_sizer->Add(bootstrap_settings_static_box_sizer, 0, wxEXPAND, 0);
    vertical_main_sizer->Add(5, 5, 0, 0, 0);

    wxStaticBoxSizer* distance_settings_sizer = new wxStaticBoxSizer(szPrefDistance_staticbox, wxVERTICAL);
    {
      distance_settings_sizer->Add(5, 5, 0, 0, 0);
      wxBoxSizer* distance_flags_sizer = new wxBoxSizer(wxHORIZONTAL);
      {
        distance_flags_sizer->Add(5, 5, 0, 0, 0);
        distance_flags_sizer->Add(rdoPrefEvolution, 0, wxEXPAND, 0);
        distance_flags_sizer->Add(5, 5, 0, 0, 0);
        //distance_flags_sizer->Add(rdoPrefMatrixExpm, 0, wxEXPAND, 0);
        //distance_flags_sizer->Add(5, 5, 0, 0, 0);
        distance_flags_sizer->Add(rdoPrefMaximum, 0, wxEXPAND, 0);
        distance_flags_sizer->Add(5, 5, 0, 0, 0);
      }
      
      distance_settings_sizer->Add(distance_flags_sizer, 0, wxEXPAND, 0);
      distance_settings_sizer->Add(5, 5, 0, 0, 0);

      wxStaticBoxSizer* ratematrix_sizer = new wxStaticBoxSizer(ratematrix_staticbox, wxHORIZONTAL);
      {
        ratematrix_sizer->Add(rate_matrix_label, 0, wxALIGN_CENTER_VERTICAL, 0);
        ratematrix_sizer->Add(5, 5, 0, 0, 0);
        ratematrix_sizer->Add(txtPrefRatematrix, 0,wxFIXED_MINSIZE , 0);
        ratematrix_sizer->Add(5, 5, 0, 0, 0);
        ratematrix_sizer->Add(btnPrefOpenRatematrix, 0, wxSHAPED|wxADJUST_MINSIZE, 0);
      }
      distance_settings_sizer->Add(ratematrix_sizer, 0, wxEXPAND, 0);
      distance_settings_sizer->Add(5, 5, 0, 0, 0);
    }
    vertical_main_sizer->Add(distance_settings_sizer, 0, wxEXPAND, 0);
    vertical_main_sizer->Add(5, 5, 0, 0, 0);
    vertical_main_sizer->Add(5, 5, 0, 0, 0);
    {
      pnj_settings_sizer->Add(5, 5, 0, 0, 0);
      pnj_settings_sizer->Add(rdoPrefPnjType, 0, wxEXPAND, 0);
      wxStaticBoxSizer* threshold_sizer = new wxStaticBoxSizer(threshold_static_box, wxVERTICAL);
      {
        threshold_sizer->Add(5, 5, 0, 0, 0);
        wxGridSizer* threshold_settings_grid_sizer = new wxGridSizer(2, 2, 5, 5);
        {
          threshold_settings_grid_sizer->Add(label_2, 0, 0, 0);
          threshold_settings_grid_sizer->Add(txtPrefProfBootValue, 0, 0, 0);
          threshold_settings_grid_sizer->Add(label_3, 0, 0, 0);
          threshold_settings_grid_sizer->Add(txtPrefProfPercentIdent, 0, 0, 0);
        }
        threshold_sizer->Add(threshold_settings_grid_sizer, 0, wxEXPAND, 0);
      }
      pnj_settings_sizer->Add(threshold_sizer, 0, wxEXPAND, 0);

      wxStaticBoxSizer* embl_staticbox_sizer = new wxStaticBoxSizer(embl_static_box, wxVERTICAL);
      {
        embl_staticbox_sizer->Add(5, 5, 0, 0, 0);
        embl_staticbox_sizer->Add(chkPrefShowOC, 0, 0, 0);
      }
      pnj_settings_sizer->Add(embl_staticbox_sizer, 1, wxEXPAND, 0);
      pnj_settings_sizer->Add(5, 5, 0, 0, 0);
    }

    vertical_main_sizer->Add(pnj_settings_sizer, 0, wxEXPAND, 0);
    vertical_main_sizer->Add(5, 5, 0, 0, 0);
    {
      tree_view_settings_grid_sizer->Add(rdoPrefTree1, 0, wxALIGN_CENTER_VERTICAL, 0);
      tree_view_settings_grid_sizer->Add(txtPrefTreeViewer1, 0, wxFIXED_MINSIZE, 0);
      tree_view_settings_grid_sizer->Add(btnPrefOpenTreeViewer1, 1, 0, 0);
      tree_view_settings_grid_sizer->Add(rdoPrefTree2, 0, wxALIGN_CENTER_VERTICAL, 0);
      tree_view_settings_grid_sizer->Add(txtPrefTreeViewer2, 1, wxFIXED_MINSIZE, 0);
      tree_view_settings_grid_sizer->Add(btnPrefOpenTreeViewer2, 0, 0, 0);
      tree_view_settings_grid_sizer->Add(rdoPrefNoneTree, 0, wxALIGN_CENTER_VERTICAL, 0);
      tree_view_settings_grid_sizer->Add(5, 5, 0, 0, 0);
      tree_view_settings_grid_sizer->Add(5, 5, 0, 0, 0);
    }
    sizer_42->Add(tree_view_settings_grid_sizer, 0, wxEXPAND, 0);
    sizer_42->Add(5, 5, 0, 0, 0);
    sizer_42->Add(text_label_1, 0, wxEXPAND, 0);
    szPrefTreeViewer->Add(sizer_42, 0, wxEXPAND, 0);
    vertical_main_sizer->Add(szPrefTreeViewer, 0, wxEXPAND, 0);
    szPrefButtons->Add(btnPrefOk, 0, 0, 0);
    szPrefButtons->Add(5, 5, 0, 0, 0);
    szPrefButtons->Add(btnPrefCancel, 0, 0, 0);
#ifndef DARWIN_SYSTEM
    szPrefButtons->Add(5, 5, 0, 0, 0);
    szPrefButtons->Add(btnPrefHelp, 0, wxRIGHT, 0);
#endif
    szPrefButtons->Add(5, 5, 0, 0, 0);
    szPrefButtons->Add(btnPrefExpert, 0, 0, 0);
    vertical_main_sizer->Add(szPrefButtons, 0, wxALIGN_RIGHT, 0);
    vertical_main_sizer->Add(5, 5, 0, 0, 0);
  }
  complete_sizer->Add(vertical_main_sizer, 1, wxEXPAND, 0);
  complete_sizer->Add(5, 5, 0, 0, 0);
  SetAutoLayout(true);
  SetSizer(complete_sizer);
  complete_sizer->Fit(this);
  complete_sizer->SetSizeHints(this);
  Layout();
  Centre();
  // end wxGlade
}
std::string MyApp::examples_path;
std::string MyApp::help_path;
std::string const& MyApp::get_help_path() { return help_path;}
std::string const& MyApp::get_examples_path() { return examples_path;}

MyApp::MyApp()
{
#ifdef DARWIN_SYSTEM
  help_path = "profdist.app/Resources/help/"; 
  examples_path = "profdist.app/Resources/";
#elif WINDOWS_SYSTEM
  help_path = "help/";
  examples_path = "examples/";
#else 
  // TODO 
  help_path = PROFDIST_SHARE "help/";
  examples_path = PROFDIST_SHARE;
#endif
}

#ifdef DARWIN_SYSTEM
OSStatus RegisterMyHelpBook(void) {
    CFBundleRef myAppsBundle;
    CFURLRef myBundleURL;
    FSRef myBundleRef;
    OSStatus err;

        /* set up a known state */
    myAppsBundle = NULL;
    myBundleURL = NULL;

        /* Get our application's main bundle
        from Core Foundation */
    myAppsBundle = CFBundleGetMainBundle();
    if (myAppsBundle == NULL) { err = fnfErr; goto bail;}

        /* retrieve the URL to our bundle */
    myBundleURL = CFBundleCopyBundleURL(myAppsBundle);
    if (myBundleURL == nil) { err = fnfErr; goto bail;}

        /* convert the URL to a FSRef */
    if ( ! CFURLGetFSRef(myBundleURL, &myBundleRef) ) {
        err = fnfErr;
        goto bail;
    }

        /* register our application's help book */
    err = AHRegisterHelpBook(&myBundleRef);
    if (err != noErr) goto bail;

        /* done */
    CFRelease(myBundleURL);
    return noErr;

bail:
    if (myBundleURL != NULL) CFRelease(myBundleURL);
    return err;
}
#endif




IMPLEMENT_APP( MyApp )


  // 2. backtrace schreiben
#ifndef WINDOWS_SYSTEM
void my_terminate() 
{
  std::cout << "terminate called :( logging backtrace..." << std::endl;
  std::ostringstream pid_str; 
  pid_str << getpid();
  std::string pid = pid_str.str();
  pid_t gdb_pid;
  if (0 == (gdb_pid = fork())) {
    {
      std::ofstream out("profdist_debug.cmd", std::ios::trunc);
      out << "set language c++\nbt\nquit\n";
      out.close();
    }
    int log = open("terminate.log", O_RDWR | O_CREAT);
    fchmod( log, S_IRUSR | S_IWUSR );
    lseek(log, 0, SEEK_END);
    dup2(log, 1);

    std::time_t now = std::time(0);
    std::cout << "\n\n----- sudden death at " << std::ctime(&now);
    execlp("gdb", "gdb", "-quiet", "-x", "profdist_debug.cmd", "profdist", pid.c_str(), 0);
    std::cout << "install gdb in your path if you want to have real log files!" << std::endl;
    close( log );
    std::exit(127);
  }
  waitpid(gdb_pid, 0, 0);
  std::remove("profdist_debug.cmd");
  wxMessageBox( _T("Dear beta tester of Profdist,\n"
        "This software still needs a lot of work. So please send\n"
        "the contents of terminate.log, which should be found in\n"
        "the working directory e.g. your home directory, to the\n"
        "current maintainer:\n"
        "profdist@biozentrum.uni-wuerzburg.de/\n" ), 
      _T( "Program Termination" ), // caption
      wxOK );
}
#endif

bool MyApp::OnInit()
{
#ifndef WINDOWS_SYSTEM
  unexpected_handler a = std::set_terminate( my_terminate );
#endif

#ifdef DARWIN_SYSTEM
  RegisterMyHelpBook(); 
#endif

  wxInitAllImageHandlers();
  MyFrame * mainFrame = new MyFrame( 0, -1, _T("") );

  if ( !mainFrame->loadXmlFile() )
  {
    wxMessageDialog dialog( mainFrame, _T("XML File not found!"), _T( "Error!" ), wxICON_ERROR );
    dialog.ShowModal();
    return false;
  }
  mainFrame->setSelection();
  SetTopWindow( mainFrame );
  mainFrame->Show();

  return true;
}

MyDialogProfile::MyDialogProfile( wxWindow * parent, int id, const wxString & title, const wxPoint & pos, const wxSize & size,
    long style ) : wxDialog( parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE )
{
  // begin wxGlade: MyDialogProfile::MyDialogProfile
  sizer_25_staticbox = new wxStaticBox(this, -1, _("Profiles"));
  label_4 = new wxStaticText(this, -1, _("Profile List"));
  txtProfileInput = new wxTextCtrl(this, -1, wxT(""));
  btnProfileOk = new wxButton(this, idBtnProfileOk, _("OK"));
  btnProfileCancel = new wxButton(this, idBtnProfileCancel, _("Cancel"));
#ifndef DARWIN_SYSTEM
  btnProfHelp = new wxButton(this, idBtnProfileHelp, _("Help"));
#endif

#ifndef DARWIN_SYSTEM
  help.SetTempDir( wxT( "." ) );
  help.AddBook( wxFileName( wxString( convert(MyApp::get_help_path()+ "/help.hhp").c_str()) ), wxPATH_UNIX );
#endif


  set_properties();
  do_layout();
  // end wxGlade
}


void MyDialogProfile::set_properties()
{
  // begin wxGlade: MyDialogProfile::set_properties
  SetTitle(_("Profile definition"));
  txtProfileInput->SetSize(wxSize(350, -1));
  btnProfileOk->SetFocus();
  btnProfileOk->SetDefault();
  // end wxGlade
}


void MyDialogProfile::do_layout()
{
  // begin wxGlade: MyDialogProfile::do_layout
  wxStaticText* tree_info = new wxStaticText(this, -1, _("If you are useing the windows version of treeview, please close it before clicking \"Ok\""));
  wxBoxSizer* sizer_7 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_23 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_24 = new wxBoxSizer(wxHORIZONTAL);
  wxStaticBoxSizer* sizer_25 = new wxStaticBoxSizer(sizer_25_staticbox, wxVERTICAL);
  wxBoxSizer* sizer_26 = new wxBoxSizer(wxHORIZONTAL);
  sizer_7->Add(5, 5, 0, 0, 0);
  sizer_23->Add(5, 5, 0, 0, 0);
  sizer_23->Add( tree_info,0,wxEXPAND,0 );
  sizer_23->Add(5, 5, 0, 0, 0);
  sizer_25->Add(5, 5, 0, 0, 0);
  sizer_26->Add(4, 4, 0, 0, 0);
  sizer_26->Add(label_4, 0, wxALIGN_CENTER_VERTICAL, 0);
  sizer_26->Add(5, 5, 0, 0, 0);
  sizer_26->Add(txtProfileInput, 0, wxALIGN_RIGHT, 0);
  sizer_26->Add(5, 5, 0, 0, 0);
  sizer_25->Add(sizer_26, 1, wxEXPAND, 0);
  sizer_25->Add(5, 5, 0, 0, 0);
  sizer_23->Add(sizer_25, 0, wxEXPAND, 0);
  sizer_23->Add(5, 5, 0, 0, 0);
  sizer_24->Add(btnProfileOk, 0, 0, 0);
  sizer_24->Add(5, 5, 0, 0, 0);
  sizer_24->Add(btnProfileCancel, 0, 0, 0);
#ifndef DARWIN_SYSTEM
  sizer_24->Add(5, 5, 0, 0, 0);
  sizer_24->Add(btnProfHelp, 0, 0, 0);
#endif
  sizer_23->Add(sizer_24, 0, wxALIGN_RIGHT, 0);
  sizer_23->Add(5, 5, 0, 0, 0);
  sizer_7->Add(sizer_23, 1, wxEXPAND, 0);
  sizer_7->Add(5, 5, 0, 0, 0);
  SetAutoLayout(true);
  SetSizer(sizer_7);
  sizer_7->Fit(this);
  sizer_7->SetSizeHints(this);
  Layout();
  Centre();
  // end wxGlade
}
/*
MyDialogGroup::MyDialogGroup( wxWindow * parent, int id, const wxString & title, int numProfiles, const wxPoint & pos,
    const wxSize & size, long style ) :
  wxDialog( parent, id, title, pos, size,
      wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER | wxSYSTEM_MENU | wxMAXIMIZE_BOX | wxMINIMIZE_BOX )
{
  // Set up toolbar
  wxBitmap toolBarBitmaps[2];
  toolBarBitmaps[0] = wxBitmap( arrowright_xpm );
  toolBarBitmaps[1] = wxBitmap( arrowleft_xpm );

  mNumProfiles = numProfiles;

  // begin wxGlade: MyDialogGroup::MyDialogGroup
  window_1 = new wxSplitterWindow(this, -1, wxDefaultPosition, wxDefaultSize, wxSP_3D|wxSP_BORDER);
  panel_2 = new wxPanel(window_1, -1, wxDefaultPosition, wxDefaultSize, wxNO_BORDER|wxTAB_TRAVERSAL);
  window_1_pane_1 = new wxPanel(window_1, -1, wxDefaultPosition, wxDefaultSize, wxNO_BORDER|wxTAB_TRAVERSAL);
  panel_1 = new wxPanel(window_1_pane_1, -1, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER);
  treeOrganism = new wxTreeCtrl(window_1_pane_1, idTreeOrganism, wxDefaultPosition, wxDefaultSize, wxTR_HAS_BUTTONS|wxTR_LINES_AT_ROOT|wxTR_MULTIPLE|wxTR_MULTIPLE|wxTR_DEFAULT_STYLE|wxNO_BORDER);
  btnGroupRight = new wxBitmapButton(panel_1, idBtnGroupRight, (toolBarBitmaps[0]));
  treeProfiles = new wxTreeCtrl(panel_2, idTreeProfiles, wxDefaultPosition, wxDefaultSize, wxTR_HAS_BUTTONS|wxTR_LINES_AT_ROOT|wxTR_EDIT_LABELS|wxTR_MULTIPLE|wxTR_MULTIPLE|wxTR_DEFAULT_STYLE|wxNO_BORDER);
  chkGroupLeft = new wxCheckBox(this, -1, _("Build Profile for each Sequence on left side"));
  btnGroupOk = new wxButton(this, idBtnGroupOk, _("OK"));
  btnGroupCancel = new wxButton(this, idBtnGroupCancel, _("Cancel"));
#ifndef DARWIN_SYSTEM
  btnGroupHelp = new wxButton(this, idBtnGroupHelp, _("Help"));
#endif

  set_properties();
  do_layout();
  // end wxGlade
}


void MyDialogGroup::set_properties()
{
  // begin wxGlade: MyDialogGroup::set_properties
  SetTitle(_("Profile Definiton"));
  SetSize(wxSize(694, 567));
  btnGroupRight->SetSize(wxSize(23, 23));
  btnGroupOk->SetFocus();
  btnGroupOk->SetDefault();
  // end wxGlade
}


void MyDialogGroup::do_layout()
{
  // begin wxGlade: MyDialogGroup::do_layout
  wxBoxSizer* sizer_36 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_37 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_24_copy_copy = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_27 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_18 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_41 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_38 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_35 = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer* sizer_39 = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer* sizer_40 = new wxBoxSizer(wxVERTICAL);
  sizer_36->Add(5, 5, 0, 0, 0);
  sizer_37->Add(5, 5, 0, 0, 0);
  sizer_40->Add(treeOrganism, 1, wxEXPAND, 0);
  sizer_38->Add(sizer_40, 1, wxEXPAND, 0);
  sizer_35->Add(5, 5, 0, 0, 0);
  sizer_39->Add(20, 20, 0, 0, 0);
  sizer_39->Add(btnGroupRight, 0, 0, 0);
  sizer_39->Add(10, 10, 0, 0, 0);
  sizer_35->Add(sizer_39, 1, wxEXPAND, 0);
  sizer_35->Add(5, 5, 0, 0, 0);
  panel_1->SetAutoLayout(true);
  panel_1->SetSizer(sizer_35);
  sizer_35->Fit(panel_1);
  sizer_35->SetSizeHints(panel_1);
  sizer_38->Add(panel_1, 0, wxEXPAND, 0);
    window_1_pane_1->SetAutoLayout(true);
    window_1_pane_1->SetSizer(sizer_38);
    sizer_38->Fit(window_1_pane_1);
    sizer_38->SetSizeHints(window_1_pane_1);
    sizer_41->Add(treeProfiles, 1, wxEXPAND, 0);
    panel_2->SetAutoLayout(true);
    panel_2->SetSizer(sizer_41);
    sizer_41->Fit(panel_2);
    sizer_41->SetSizeHints(panel_2);
    window_1->SplitVertically(window_1_pane_1, panel_2, 357);
    sizer_37->Add(window_1, 1, wxEXPAND, 0);
    sizer_37->Add(5, 5, 0, 0, 0);
    sizer_18->Add(chkGroupLeft, 0, wxALIGN_CENTER_VERTICAL, 0);
    sizer_24_copy_copy->Add(sizer_18, 1, wxEXPAND, 0);
    sizer_27->Add(btnGroupOk, 0, 0, 0);
    sizer_27->Add(5, 5, 0, 0, 0);
    sizer_27->Add(btnGroupCancel, 0, 0, 0);
#ifndef DARWIN_SYSTEM
    sizer_27->Add(5, 5, 0, 0, 0);
    sizer_27->Add(btnGroupHelp, 0, wxALIGN_RIGHT, 0);
#endif
    sizer_24_copy_copy->Add(sizer_27, 0, wxALIGN_RIGHT, 0);
    sizer_37->Add(sizer_24_copy_copy, 0, wxEXPAND, 0);
    sizer_37->Add(5, 5, 0, 0, 0);
    sizer_36->Add(sizer_37, 1, wxEXPAND, 0);
    sizer_36->Add(5, 5, 0, 0, 0);
    SetAutoLayout(true);
    SetSizer(sizer_36);
    Layout();
    Centre();
    // end wxGlade
}
*/

MyDialogAbout::MyDialogAbout(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE)
{
  // Set up toolbar
   wxBitmap aboutBitmaps[1];
   aboutBitmaps[0] = wxBitmap( about_xpm );

    // begin wxGlade: MyDialogAbout::MyDialogAbout
    bitmap_1 = new wxStaticBitmap(this, -1, (aboutBitmaps[0]));
    label_5 = new wxStaticText(this, -1, ( convert(std::string("Version " PACKAGE_VERSION " on C++ with boost-" BOOST_LIB_VERSION " and\n")) + wxVERSION_STRING ).c_str(), wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT);
    mHyperWx = new wxHyperlinksCtrl(this, idLinkWx, _T("http://www.wxwidgets.org"), wxPoint(70,30), wxDefaultSize, 0, _T("statictextlink2"), _T("http://www.wxwidgets.org"));
    mHyperBoost = new wxHyperlinksCtrl(this, idLinkBoost, _T("http://www.boost.org"), wxPoint(70,30), wxDefaultSize, 0, _T("statictextlink3"), _T("http://www.boost.org"));

    set_properties();
    do_layout();
    // end wxGlade

    // Default Web links:
    //    wxHyperlinksCtrl *m_hyper1 = new wxHyperlinksCtrl( this, idLinkWx, "http://www.spaceblue.com",
    //                     wxPoint(70,30), wxDefaultSize, 0, "statictextlink2", "http://www.spaceblue.com" );

}

void MyDialogAbout::set_properties()
{
    // begin wxGlade: MyDialogAbout::set_properties
    SetTitle(_("About ProfDist"));
    // end wxGlade
}


void MyDialogAbout::do_layout()
{
    // begin wxGlade: MyDialogAbout::do_layout
    wxBoxSizer* sizer_31 = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer* sizer_32 = new wxBoxSizer(wxVERTICAL);
    sizer_31->Add(5, 5, 0, 0, 0);
    sizer_32->Add(5, 5, 0, 0, 0);
    sizer_32->Add(bitmap_1, 0, 0, 0);
    sizer_32->Add(5, 5, 0, 0, 0);
    sizer_32->Add(label_5, 0, 0, 0);
    sizer_32->Add(5, 5, 0, 0, 0);
    sizer_32->Add(mHyperWx, 1, wxEXPAND, 0);
    sizer_32->Add(5, 5, 0, 0, 0);
    sizer_32->Add(mHyperBoost, 1, wxEXPAND, 0);
    sizer_32->Add(5, 5, 0, 0, 0);
    sizer_31->Add(sizer_32, 1, wxEXPAND, 0);
    sizer_31->Add(5, 5, 0, 0, 0);
    SetAutoLayout(true);
    SetSizer(sizer_31);
    sizer_31->Fit(this);
    sizer_31->SetSizeHints(this);
    Layout();
    // end wxGlade
}


