/***************************************************************************
 *   Copyright (C) 2005 by Andreas Pokorny                                 *
 *   andreas.pokorny@biozentrum.uni-wuerzburg.de                           *
 *                                                                         *
 *   This file is part of profdist and cbcanalyzer                         *
 *                                                                         *
 *   Both profdist and cbcanalyzer are free software; you can redistribute * 
 *   it and/or modify it under the terms of the GNU General Public License * 
 *   as published by the Free Software Foundation; either version 2 of the * 
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   Profdist and cbcanalyzer are distributed in the hope that it will be  *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "progress_dialog.h"
#include "converter.h"

/*
ProgressDialog::ProgressDialog( wxString const& title, wxString const& text, size_t max, wxWindow * parent, size_t flags )
  : wxProgressDialog( title, text, max, parent, flags )
{
}

bool ProgressDialog::update( std::size_t pos, std::string const& status ) 
{
  return Update( pos, convert(status) );
}*/



BEGIN_EVENT_TABLE(ProgressDialog, wxDialog)
	EVT_BUTTON(idButtonPgD, ProgressDialog::buttonClicked)
	EVT_CLOSE(ProgressDialog::onClose)
END_EVENT_TABLE()


ProgressDialog::ProgressDialog( wxString const& title, wxString const& text, size_t max, wxWindow * parent, size_t flags )
  : wxDialog(parent, -1, title, wxDefaultPosition, wxSize(400, 200), wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER),
  _gauge(new wxGauge(this, -1, max, wxDefaultPosition, wxSize(400, 30))),
  _label(new wxStaticText(this, -1, (text != wxString(_T("")) ? text.GetData() : _T("Computing distance matrices")))),
  _button(new wxButton(this, idButtonPgD, _T("Cancel"))),
  _go(true)
{
	do_layout();
	Show(true);
// 	if(GetParent())
// 		GetParent()->Enable(false);
	wxWindow::Update();
	wxYield();
}

ProgressDialog::~ProgressDialog()
{
// 	if(GetParent())
// 		GetParent()->Enable(true);
}

bool ProgressDialog::update(std::size_t pos, std::string const& status)
{
	_gauge->SetValue(pos);
	wxWindow::Update();
	wxYield();
	return _go;
}

void ProgressDialog::do_layout()
{
	wxBoxSizer* sizer = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer* sizer2 = new wxBoxSizer(wxHORIZONTAL);
	sizer->Add(_label, 0, wxALIGN_LEFT | wxALL, 10);
	sizer2->Add(_gauge, 1, wxEXPAND | wxALL, 10);
	sizer->Add(sizer2, 0, wxALIGN_CENTER);
	sizer->Add(_button, 0, wxALIGN_CENTER | wxALL, 10);
	sizer->Fit(this);
	sizer->SetSizeHints(this);
	SetSizer(sizer);
	Layout();
}

void ProgressDialog::Resume()
{
	_go = true;
}

void ProgressDialog::buttonClicked(wxCommandEvent& WXUNUSED(event))
{
	_go = false;
}

void ProgressDialog::onClose(wxCloseEvent& WXUNUSED(event))
{
	_go = false;
}

