/***************************************************************************
 *   Copyright (C) 2005 by Andreas Pokorny                                 *
 *   andreas.pokorny@biozentrum.uni-wuerzburg.de                           *
 *                                                                         *
 *   This file is part of profdist and cbcanalyzer                         *
 *                                                                         *
 *   Both profdist and cbcanalyzer are free software; you can redistribute * 
 *   it and/or modify it under the terms of the GNU General Public License * 
 *   as published by the Free Software Foundation; either version 2 of the * 
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   Profdist and cbcanalyzer are distributed in the hope that it will be  *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PROFDIST_TRAITS_CHOOSER_H_INCLUDED
#define PROFDIST_TRAITS_CHOOSER_H_INCLUDED

#include <string>
#include <vector>
#include <map>
#include <list>
#include <wx/dialog.h> 
#include <wx/panel.h> 
#include <wx/checkbox.h>
#include <wx/radiobox.h>
#include <wx/sizer.h>
#include "types.h"

class TraitsDialog : public wxDialog
{
  public:
    enum ButtonIds {
      //TreatAsRna = 0
    //, TreatAsProteine
		ButtonOk = 0,
		ButtonCancel
    };
	
	enum Choice {
		TreatAsRna = 0,
		TreatAsProteine,
		Cancel = 100
	};
	
    TraitsDialog( wxWindow * parent, int id
        , wxPoint const & pos = wxDefaultPosition
        , wxSize const & size = wxDefaultSize
        , long style = wxDEFAULT_DIALOG_STYLE );

//     void on_rna( wxCommandEvent & WXUNUSED( event ) );
//     void on_proteine( wxCommandEvent & WXUNUSED( event ) );
	
	void onButtonOk( wxCommandEvent & WXUNUSED( event ) );
	void onButtonCancel( wxCommandEvent & WXUNUSED( event ) );

  private:
    void construct_ui();
    void set_properties();
    void do_layout();
    DECLARE_EVENT_TABLE();

  protected :
    // begin wxGlade: MyDialogGroup::attributes
    wxPanel* panel;
    //wxButton *rna_button, *proteine_button;
	wxRadioBox *radiobox;
	wxButton *ok_button, *cancel_button;
};

#endif

