/***************************************************************************
 *   Copyright (C) 2005 by Joachim Friedrich                               *
 *   joachim.friedrich@biozentrum.uni-wuerzburg.de                         *
 *                                                                         *
 *   This file is part of profdist and cbcanalyzer                         *
 *                                                                         *
 *   Both profdist and cbcanalyzer are free software; you can redistribute * 
 *   it and/or modify it under the terms of the GNU General Public License * 
 *   as published by the Free Software Foundation; either version 2 of the * 
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   Profdist and cbcanalyzer are distributed in the hope that it will be  *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PROFDIST_WX_EVENT_H_INCLUDED
#define PROFDIST_WX_EVENT_H_INCLUDED

// IDs for the controls and the menu commands


//---------------------------------------------------------------------------
//
//  name          : onBtnPnjOpenFile
//
//  description   : Load a text file in Input Window from Profile Neighbor Joining
//
//  input         : *this
//
//  return value  : void
//
//---------------------------------------------------------------------------

BEGIN_EVENT_TABLE( MyFrame, wxFrame ) // begin
     EVT_CHECKBOX( idChkBootInput, MyFrame::onChkBootInput ) //
     EVT_CHECKBOX( idChkDistInput, MyFrame::onChkDistInput ) //
     EVT_CHECKBOX( idChkNjInput, MyFrame::onChkNjInput ) //
     EVT_CHECKBOX( idChkPnjInput, MyFrame::onChkPnjInput ) //
     EVT_CHECKBOX( idChkBootOutput, MyFrame::onChkBootOutput ) //
     EVT_CHECKBOX( idChkDistOutput, MyFrame::onChkDistOutput ) //
     EVT_CHECKBOX( idChkNjOutput, MyFrame::onChkNjOutput ) //
     EVT_CHECKBOX( idChkPnjOutput, MyFrame::onChkPnjOutput ) //

     EVT_MENU( idMnuOpen, MyFrame::onMnuOpen ) //
     EVT_MENU( idMnuSave, MyFrame::onMnuSave ) //
     EVT_MENU( idMnuExit, MyFrame::onMnuExit ) //

     EVT_MENU( idMnuUndo, MyFrame::onMnuUndo ) //
     EVT_MENU( idMnuCut, MyFrame::onMnuCut ) //
     EVT_MENU( idMnuCopy, MyFrame::onMnuCopy ) //
     EVT_MENU( idMnuPaste, MyFrame::onMnuPaste ) //
     EVT_MENU( idMnuSelectAll, MyFrame::onMnuSelectAll ) //
     EVT_MENU( idMnuPref, MyFrame::onMnuPref ) //

     EVT_MENU( idMnuStart, MyFrame::onMnuStart ) //
     EVT_MENU( idMnuTreeView, MyFrame::onMnuTreeView ) //
     EVT_MENU( idMnuGamma, MyFrame::onMnuGamma ) //

     EVT_MENU( idMnuHelp, MyFrame::onMnuHelp ) //
     EVT_MENU( idMnuAbout, MyFrame::onMnuAbout ) //

     EVT_NOTEBOOK_PAGE_CHANGED( idNtbAll, MyFrame::onNotebook ) //

     EVT_CLOSE( MyFrame::onCloseEvent ) //

     END_EVENT_TABLE() // end

     //---------------------------------------------------------------------------
     //
     //  name          : onBtnPnjOpenFile
     //
     //  description   : Load a text file in Input Window from Profile Neighbor Joining
     //
     //  input         : *this
     //
     //  return value  : void
     //
     //---------------------------------------------------------------------------
     BEGIN_EVENT_TABLE( MyDialogPref, wxDialog ) // begin

     EVT_BUTTON( idBtnPrefOpenTreeViewer1, MyDialogPref::onBtnPrefOpenTreeViewer1 ) //
     EVT_BUTTON( idBtnPrefOpenTreeViewer2, MyDialogPref::onBtnPrefOpenTreeViewer2 ) //
     EVT_BUTTON( idBtnPrefOpenRatematrix, MyDialogPref::onBtnPrefOpenRatematrix ) //
     EVT_BUTTON( idBtnPrefOk, MyDialogPref::onBtnPrefOk ) //
     EVT_BUTTON( idBtnPrefCancel, MyDialogPref::onBtnPrefCancel ) //
     EVT_BUTTON( idBtnPrefHelp, MyDialogPref::onBtnPrefHelp ) //
     EVT_BUTTON( idBtnPrefExpert, MyDialogPref::onBtnPrefExpert ) //

     EVT_RADIOBUTTON( idRdoPrefTree1, MyDialogPref::onRdoPrefTree1 ) //
     EVT_RADIOBUTTON( idRdoPrefTree2, MyDialogPref::onRdoPrefTree2 ) //
     EVT_RADIOBUTTON( idRdoPrefHypertree, MyDialogPref::onRdoPrefHypertree ) //
     EVT_RADIOBUTTON( idRdoPrefNone, MyDialogPref::onRdoPrefNone ) //

     EVT_RADIOBOX( idRdoPrefEvolution, MyDialogPref::onRdoPrefEvolution ) //

     END_EVENT_TABLE() // end


     BEGIN_EVENT_TABLE( MyDialogProfile, wxDialog ) // begin

     EVT_BUTTON( idBtnProfileOk, MyDialogProfile::onBtnProfileOk ) //
     EVT_BUTTON( idBtnProfileCancel, MyDialogProfile::onBtnProfileCancel ) //
     EVT_BUTTON( idBtnProfileHelp, MyDialogProfile::onBtnProfileHelp ) //

     END_EVENT_TABLE() // end


     /*BEGIN_EVENT_TABLE( MyDialogGroup, wxDialog ) // begin

     EVT_BUTTON( idBtnGroupRight, MyDialogGroup::onBtnGroupRight ) //
     EVT_BUTTON( idBtnGroupLeft, MyDialogGroup::onBtnGroupLeft ) //
     EVT_BUTTON( idBtnGroupOk, MyDialogGroup::onBtnGroupOk ) //
     EVT_BUTTON( idBtnGroupCancel, MyDialogGroup::onBtnGroupCancel ) //
     EVT_BUTTON( idBtnGroupHelp, MyDialogGroup::onBtnGroupHelp ) //

     EVT_TREE_ITEM_RIGHT_CLICK( idTreeOrganism, MyDialogGroup::OnItemRightClick )
     EVT_TREE_ITEM_RIGHT_CLICK( idTreeProfiles, MyDialogGroup::OnItemRightClick )

     END_EVENT_TABLE() // end
*/
     BEGIN_EVENT_TABLE( MyDialogAbout, wxDialog ) // begin

     EVT_LINK( idLinkWx, MyDialogAbout::onLinkWx ) //
     EVT_LINK( idLinkBoost, MyDialogAbout::onLinkBoost ) //

     END_EVENT_TABLE() // end

#endif

