/***************************************************************************
 *   Copyright (C) 2005 by Andreas Pokorny                                 *
 *   andreas.pokorny@biozentrum.uni-wuerzburg.de                           *
 *                                                                         *
 *   This file is part of profdist and cbcanalyzer                         *
 *                                                                         *
 *   Both profdist and cbcanalyzer are free software; you can redistribute * 
 *   it and/or modify it under the terms of the GNU General Public License * 
 *   as published by the Free Software Foundation; either version 2 of the * 
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   Profdist and cbcanalyzer are distributed in the hope that it will be  *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the      *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <cstring>
#include "rna_structure_mapper.hpp"

profdist::rna_structure_mapper::rna_structure_mapper()
{
  std::memset( rna_s_to_code, 4, 128);

  rna_s_to_code[0] = 0;
  rna_s_to_code[1] = 1;
  rna_s_to_code[2] = 2;
  rna_s_to_code[3] = 3;

  rna_s_to_code['A'] = rna_s_to_code['a'] = 0;
  rna_s_to_code['C'] = rna_s_to_code['c'] = 1;
  rna_s_to_code['G'] = rna_s_to_code['g'] = 2;
  rna_s_to_code['U'] = rna_s_to_code['u'] = rna_s_to_code['T'] = rna_s_to_code['t'] = 3;

  code_to_rna_s[0] = std::make_pair( 'A', '.' );
  code_to_rna_s[1] = std::make_pair( 'C', '.' );
  code_to_rna_s[2] = std::make_pair( 'G', '.' );
  code_to_rna_s[3] = std::make_pair( 'T', '.' );
  code_to_rna_s[4] = std::make_pair( 'A', '(' );
  code_to_rna_s[5] = std::make_pair( 'C', '(' );
  code_to_rna_s[6] = std::make_pair( 'G', '(' );
  code_to_rna_s[7] = std::make_pair( 'T', '(' );
  code_to_rna_s[8] = std::make_pair( 'A', ')' );
  code_to_rna_s[9] = std::make_pair( 'C', ')' );
  code_to_rna_s[10] = std::make_pair( 'G', ')' );
  code_to_rna_s[11] = std::make_pair( 'T', ')' );
  code_to_rna_s[12] = std::make_pair( 'N', '.' );
  code_to_rna_s[13] = std::make_pair( 'N', '(' );
  code_to_rna_s[14] = std::make_pair( 'N', ')' );
 }

profdist::rna_structure_mapper& profdist::rna_structure_mapper::get_instance()
{
  static rna_structure_mapper instance;
  return instance;
}


